Public Class Form1
    ' Generate and display the permutations.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Const ASC_A As Integer = 65

        lstResults.Items.Clear()
        txtCombinations.Text = ""
        Application.DoEvents()

        ' Generate a collection of letters to permute.
        Dim num_values As Integer = Val(txtNumItems.Text)
        Dim values As New Collection
        For i As Integer = 0 To num_values - 1
            values.Add(Chr(ASC_A + i))
        Next i

        ' Generate the permutations.
        Dim permutations As Collection = GeneratePermutations(values)

        ' Display the results.
        For Each perm As Collection In permutations
            ' Display result perm.
            Dim txt As String = ""
            For Each item As Object In perm
                txt &= item.ToString()
            Next item
            lstResults.Items.Add(txt)
        Next perm

        txtCombinations.Text = Format$(Factorial(num_values))
    End Sub

    ' Return the factorial of the number.
    Private Function Factorial(ByVal num As Long) As Long
        Dim result As Long = 1
        For i As Integer = 2 To num
            result *= i
        Next i
        Return result
    End Function

    ' Generate permutations of the values in the
    ' values collection.
    ' Return the result through a collection of
    ' collections that each hold a permutation.
    Private Function GeneratePermutations(ByVal values As Collection) As Collection
        Dim results As New Collection

        ' See if there is only one value.
        If values.Count = 1 Then
            ' Return a collection containing one
            ' permutation equal to the single value.
            results.Add(New Collection)
            results.Item(1).Add(values.Item(1))
            Return results
        End If

        ' Build permutations starting with
        ' each possible first item.
        results = New Collection
        Dim num_values As Integer = values.Count
        For i As Integer = 1 To num_values
            ' Save this value.
            Dim first_value As Object = values.Item(i)

            ' Remove the item.
            values.Remove(i)

            ' Generate the permutations of the
            ' remaining values.
            Dim new_permutations As Collection = GeneratePermutations(values)

            ' Make permutations by adding first_value
            ' to the beginning of each of the new
            ' permutations.
            For j As Integer = 1 To new_permutations.Count
                ' Add the first item.
                Dim new_result As New Collection
                new_result.Add(first_value)

                ' Add the rest of the items in the jth
                ' new permutation.
                For k As Integer = 1 To new_permutations(j).Count
                    new_result.Add(new_permutations(j).Item(k))
                Next k

                ' Add this new permutation to the results.
                results.Add(new_result)
            Next j

            ' Restore the removed value.
            If i > values.Count Then
                values.Add(first_value)
            Else
                values.Add(first_value, , i)
            End If
        Next i

        ' Return the results.
        Return results
    End Function
End Class
